LOCAL_PATH := $(call my-dir)
SRC_DIR := ../src

include $(CLEAR_VARS)

LOCAL_MODULE    := phidget22

LOCAL_CFLAGS := \
	-DUNIX \
	-D_ANDROID \
	-DLinux \
	-DMOS_BYTE_ORDER=MOS_LITTLE_ENDIAN \
	-D_MOS_PTHREADS \
	-DHAVE_IPV6 \
	-DHAVE_LINUX \
	-DNOT_HAVE_SA_LEN \
	-DPLATFORM_NO_RLIMIT \
	-DTARGET_OS_LINUX \
	-DUSES_NETLINK \
	-DMDNS_DEBUGMSGS=0 \
	-DMDNS_UDS_SERVERPATH=\"/dev/socket/mdnsd\" \
	-DMDNS_USERNAME=\"mdnsr\" \

LOCAL_C_INCLUDES := $(LOCAL_PATH)/$(SRC_DIR) $(LOCAL_PATH)/$(SRC_DIR)/ext $(LOCAL_PATH)/$(SRC_DIR)/ext/include

LOCAL_SRC_FILES := \
	$(SRC_DIR)/analogsensor.c \
	$(SRC_DIR)/bridge.c \
	$(SRC_DIR)/bridgepackets.gen.c \
	$(SRC_DIR)/class/accelerometer.c \
	$(SRC_DIR)/class/bldcmotor.c \
	$(SRC_DIR)/class/capacitivetouch.c \
	$(SRC_DIR)/class/currentinput.c \
	$(SRC_DIR)/class/dataadapter.c \
	$(SRC_DIR)/class/dcmotor.c \
	$(SRC_DIR)/class/dictionary.c \
	$(SRC_DIR)/class/digitalinput.c \
	$(SRC_DIR)/class/digitaloutput.c \
	$(SRC_DIR)/class/distancesensor.c \
	$(SRC_DIR)/class/encoder.c \
	$(SRC_DIR)/class/firmwareupgrade.c \
	$(SRC_DIR)/class/frequencycounter.c \
	$(SRC_DIR)/class/generic.c \
	$(SRC_DIR)/class/gps.c \
	$(SRC_DIR)/class/gyroscope.c \
	$(SRC_DIR)/class/hub.c \
	$(SRC_DIR)/class/humiditysensor.c \
	$(SRC_DIR)/class/ir.c \
	$(SRC_DIR)/class/lcd.c \
	$(SRC_DIR)/class/lightsensor.c \
	$(SRC_DIR)/class/magnetometer.c \
	$(SRC_DIR)/class/meshdongle.c \
	$(SRC_DIR)/class/motorpositioncontroller.c \
	$(SRC_DIR)/class/phsensor.c \
	$(SRC_DIR)/class/powerguard.c \
	$(SRC_DIR)/class/pressuresensor.c \
	$(SRC_DIR)/class/rcservo.c \
	$(SRC_DIR)/class/resistanceinput.c \
	$(SRC_DIR)/class/rfid.c \
	$(SRC_DIR)/class/soundsensor.c \
	$(SRC_DIR)/class/spatial.c \
	$(SRC_DIR)/class/stepper.c \
	$(SRC_DIR)/class/temperaturesensor.c \
	$(SRC_DIR)/class/voltageinput.c \
	$(SRC_DIR)/class/voltageoutput.c \
	$(SRC_DIR)/class/voltageratioinput.c \
	$(SRC_DIR)/constants.c \
	$(SRC_DIR)/datainterval.gen.c \
	$(SRC_DIR)/debug.c \
	$(SRC_DIR)/device/accelerometerdevice.c \
	$(SRC_DIR)/device/advancedservodevice.c \
	$(SRC_DIR)/device/analogdevice.c \
	$(SRC_DIR)/device/bridgedevice.c \
	$(SRC_DIR)/device/dictionarydevice.c \
	$(SRC_DIR)/device/encoderdevice.c \
	$(SRC_DIR)/device/firmwareupgradedevice.c \
	$(SRC_DIR)/device/frequencycounterdevice.c \
	$(SRC_DIR)/device/genericdevice.c \
	$(SRC_DIR)/device/gpsdevice.c \
	$(SRC_DIR)/device/hubdevice.c \
	$(SRC_DIR)/device/interfacekitdevice.c \
	$(SRC_DIR)/device/irdevice.c \
	$(SRC_DIR)/device/leddevice.c \
	$(SRC_DIR)/device/meshdongledevice.c \
	$(SRC_DIR)/device/motorcontroldevice.c \
	$(SRC_DIR)/device/phsensordevice.c \
	$(SRC_DIR)/device/rfiddevice.c \
	$(SRC_DIR)/device/servodevice.c \
	$(SRC_DIR)/device/spatialdevice.c \
	$(SRC_DIR)/device/stepperdevice.c \
	$(SRC_DIR)/device/temperaturesensordevice.c \
	$(SRC_DIR)/device/textlcddevice.c \
	$(SRC_DIR)/device/vintdevice.c \
	$(SRC_DIR)/devices.c \
	$(SRC_DIR)/dispatch.c \
	$(SRC_DIR)/enumutil.gen.c \
	$(SRC_DIR)/errorstrings.gen.c \
	$(SRC_DIR)/ext/cvtutf.c \
	$(SRC_DIR)/ext/md5.c \
	$(SRC_DIR)/ext/mos/base64.c \
	$(SRC_DIR)/ext/mos/base.c \
	$(SRC_DIR)/ext/mos/crc32.c \
	$(SRC_DIR)/ext/mos/ctype.c \
	$(SRC_DIR)/ext/mos/endswith.c \
	$(SRC_DIR)/ext/mos/getcwd.c \
	$(SRC_DIR)/ext/mos/getenv.c \
	$(SRC_DIR)/ext/mos/getopt.c \
	$(SRC_DIR)/ext/mos/getpasswd-unix.c \
	$(SRC_DIR)/ext/mos/glob.c \
	$(SRC_DIR)/ext/mos/glock.c \
	$(SRC_DIR)/ext/mos/hexdump.c \
	$(SRC_DIR)/ext/mos/init_daemon.c \
	$(SRC_DIR)/ext/mos/iop.c \
	$(SRC_DIR)/ext/mos/kv/kv.c \
	$(SRC_DIR)/ext/mos/kv/kvent.c \
	$(SRC_DIR)/ext/mos/kv/parse.c \
	$(SRC_DIR)/ext/mos/kv/scan.c \
	$(SRC_DIR)/ext/mos/malloc.c \
	$(SRC_DIR)/ext/mos/malloc-user.c \
	$(SRC_DIR)/ext/mos/md5c.c \
	$(SRC_DIR)/ext/mos/memchr.c \
	$(SRC_DIR)/ext/mos/memcmp.c \
	$(SRC_DIR)/ext/mos/memmem.c \
	$(SRC_DIR)/ext/mos/mkdirp.c \
	$(SRC_DIR)/ext/mos/mos_atomic-pthread.c \
	$(SRC_DIR)/ext/mos/mos_dl-unix.c \
	$(SRC_DIR)/ext/mos/mos_error-errno.c \
	$(SRC_DIR)/ext/mos/mos_fileio-unix-user.c \
	$(SRC_DIR)/ext/mos/mos_lock-pthread.c \
	$(SRC_DIR)/ext/mos/mos_net.c \
	$(SRC_DIR)/ext/mos/mos_netops-unix.c \
	$(SRC_DIR)/ext/mos/mos_os.c \
	$(SRC_DIR)/ext/mos/mos_random-unix.c \
	$(SRC_DIR)/ext/mos/mos_setenv-native.c \
	$(SRC_DIR)/ext/mos/mos_stacktrace-gnu.c \
	$(SRC_DIR)/ext/mos/mos_task-pthread.c \
	$(SRC_DIR)/ext/mos/mos_time-unix.c \
	$(SRC_DIR)/ext/mos/mos_tlock.c \
	$(SRC_DIR)/ext/mos/path.c \
	$(SRC_DIR)/ext/mos/pkcs5_pbkdf2.c \
	$(SRC_DIR)/ext/mos/printf-smart.c \
	$(SRC_DIR)/ext/mos/process-unix.c \
	$(SRC_DIR)/ext/mos/rand48.c \
	$(SRC_DIR)/ext/mos/random.c \
	$(SRC_DIR)/ext/mos/readdir-unix.c \
	$(SRC_DIR)/ext/mos/readline.c \
	$(SRC_DIR)/ext/mos/rwrlock.c \
	$(SRC_DIR)/ext/mos/scanf.c \
	$(SRC_DIR)/ext/mos/sha1.c \
	$(SRC_DIR)/ext/mos/sha2.c \
	$(SRC_DIR)/ext/mos/snprintf.c \
	$(SRC_DIR)/ext/mos/strcasecmp.c \
	$(SRC_DIR)/ext/mos/strchr.c \
	$(SRC_DIR)/ext/mos/strcmp.c \
	$(SRC_DIR)/ext/mos/strdup.c \
	$(SRC_DIR)/ext/mos/strlcat.c \
	$(SRC_DIR)/ext/mos/strlcpy.c \
	$(SRC_DIR)/ext/mos/strlen.c \
	$(SRC_DIR)/ext/mos/strncmp.c \
	$(SRC_DIR)/ext/mos/strncpy.c \
	$(SRC_DIR)/ext/mos/strnsep.c \
	$(SRC_DIR)/ext/mos/strnstr.c \
	$(SRC_DIR)/ext/mos/strrchr.c \
	$(SRC_DIR)/ext/mos/strrev.c \
	$(SRC_DIR)/ext/mos/strstr.c \
	$(SRC_DIR)/ext/mos/strton.c \
	$(SRC_DIR)/ext/mos/strtrim.c \
	$(SRC_DIR)/ext/mos/time.c \
	$(SRC_DIR)/ext/mos/urldecode.c \
	$(SRC_DIR)/ext/mos/urlencode.c \
	$(SRC_DIR)/ext/mos/vasprintf.c \
	$(SRC_DIR)/formatters.c \
	$(SRC_DIR)/gpp.c \
	$(SRC_DIR)/lightning.c \
	$(SRC_DIR)/manager.c \
	$(SRC_DIR)/mesh.c \
	$(SRC_DIR)/network/channel.c \
	$(SRC_DIR)/network/client.c \
	$(SRC_DIR)/network/network.c \
	$(SRC_DIR)/network/networkcontrol.c \
	$(SRC_DIR)/network/server.c \
	$(SRC_DIR)/network/servers.c \
	$(SRC_DIR)/network/zeroconf.c \
	$(SRC_DIR)/object.c \
	$(SRC_DIR)/phidget.c \
	$(SRC_DIR)/phidget22.c \
	$(SRC_DIR)/spi.c \
	$(SRC_DIR)/stats.c \
	$(SRC_DIR)/supportedpacket.gen.c \
	$(SRC_DIR)/usb.c \
	$(SRC_DIR)/util/config.c \
	$(SRC_DIR)/util/jsmn.c \
	$(SRC_DIR)/util/json.c \
	$(SRC_DIR)/util/log.c \
	$(SRC_DIR)/util/packettracker.c \
	$(SRC_DIR)/util/packing.c \
	$(SRC_DIR)/util/utils.c \
	$(SRC_DIR)/vint.c \
	$(SRC_DIR)/vintpackets.c \
	$(SRC_DIR)/virtual.c \
	$(SRC_DIR)/plat/android/usbandroid.c \
	$(SRC_DIR)/plat/android/com_phidget22_usb_Manager.c \
	$(SRC_DIR)/plat/android/com_phidget22_usb_Phidget.c \
	$(SRC_DIR)/ext/mdnsclient/dnssd_clientlib.c \
	$(SRC_DIR)/ext/mdnsclient/dnssd_clientstub.c \
	$(SRC_DIR)/ext/mdnsclient/dnssd_ipc.c

include $(BUILD_STATIC_LIBRARY)
